  'init and detect
  beat=100 'ms
  cnt=20  'beats
  
  dim CTRL_DRIVER$ = "ctrl_none$"
  WII CLASSIC open
  if mm.errno=0 then wwii=device(wii T) else wwii=0
  if wwii=&hA4200101 then                     ' wii classic controller
    CTRL_DRIVER$ = "ctrl_wii_classic$"        ' select Wii Classic controller
  end if
  
  print ctrl_driver$
  
  'start play mod files
  play modfile "music/get_psyched-sfx.mod"
  
  'game loop
  timer=0
  do
    inc i
    if i>cnt then
      i=0
      play modsample 17,4
    end if
    do : loop until timer > beat
    timer=0
    tmp$=read_input$()
    print ".";
  loop
  
  'subs -----------------
  
Function ctrl_none$(init)
End Function
  
Function read_input$()
  Static last$
  read_input$ = read_inkey$()
  If Len(read_input$) Then Exit Function
  read_input$ = Call(CTRL_DRIVER$)
End Function
  
  
Function read_inkey$()
  Select Case Asc(Inkey$)
      Case 0   : Exit Function
      Case 9   : read_inkey$ = "map"          ' Tab
      Case 27  : read_inkey$ = "escape"
      Case 32  : read_inkey$ = "use-item"     ' Space
      Case 77  : read_inkey$ = "toggle-music" ' M
      Case 97  : read_inkey$ = "fire-left"    ' a
      Case 100 : read_inkey$ = "fire-right"   ' d
      Case 109 : read_inkey$ = "move"         ' m
      Case 115 : read_inkey$ = "fire-down"    ' s
      Case 119 : read_inkey$ = "fire-up"      ' w
      Case 121, 122 : read_inkey$ = "search"  ' y, z
      Case 128 : read_inkey$ = "up"
      Case 129 : read_inkey$ = "down"
      Case 130 : read_inkey$ = "left"
      Case 131 : read_inkey$ = "right"
      Case 145 : read_inkey$ = "toggle-weapon" ' F1
      Case 146 : read_inkey$ = "toggle-item"   ' F2
      Case 147 : read_inkey$ = "cheat"         ' F3
      Case 148 : read_inkey$ = "kill-all"      ' F4
  End Select
End Function
  
Function ctrl_wii_classic$(init)
  If Not init Then
    Local bits, i, s$
    bits = Device(Wii b)
    If bits Then
      Select Case bits
          Case &h0001 : s$ = "toggle-item"   ' R shoulder button
          Case &h0002 : s$ = "use-item"      ' Start
          Case &h0004 : s$ = "map"           ' Home
          Case &h0008 : s$ = "escape"        ' Select
          Case &h0010 : s$ = "toggle-weapon" ' L shoulder button
          Case &h0020 : s$ = "fire-down"     ' Cursor down
          Case &h0040 : s$ = "fire-right"    ' Cursor right
          Case &h0080 : s$ = "fire-up"       ' Cursor up
          Case &h0100 : s$ = "fire-left"     ' Cursor left
          Case &h0800 : s$ = "move"          ' Button A
          Case &h2000 : s$ = "search"        ' Button B
      End Select
    Else
      ' Right analog joystick.
      Select Case Device(Wii RY)
          Case < 50  : s$ = "down"
          Case > 205 : s$ = "up"
      End Select
      Select Case Device(Wii RX)
          Case < 50  : s$ = "left"
          Case > 205 : s$ = "right"
      End Select
    EndIf
    
    ctrl_wii_classic$ = s$
    Exit Function
  Else
    Device Wii Open
  EndIf
End Function
